
# include "occam.h"

/* we assume that statements begin at the keyword and
   don't print their trailing \n
 */

@ process(n)     = skip 
@                | stop 
@                | action 
@                | construction(n)
@                | instance 
@                | specification clause(n)

@ skip           = _SKIP            :printf("skip");:
@                  $!

@ stop           = _STOP            :printf("stop");:
@                  $!

@ action         = assignment | input | output

@ assignment     =                  :printf("[");:
@                  multiassign(CONST(1))
@                                   :printf("]");:
@                  $!

@ input          = channel <'?'>    :printf("?");:
@                  variable $!

@ output         = channel <'!'>    :printf("!");:
@                  expression $!

/* at least n simultaneous assigns */

# define ASS "]:=["

/* this is the n'th variable in the assign list coming up now */

@ multiassign(n) = variable
@                { <':'> <'='>      :printf(ASS);:
@                  expressionlist(n)
@                | <','>            :printf(",");:
@                  multiassign(n+1) }

/* a comma separated list of n expressions */

@ expressionlist(n)= expression
@                  { <','>           :printf(",");:
@                    expressionlist(n-1) }*(n-1)


