/*# include "cc.h"*/
# include "occam.h"


@ operand        = element
@                | literal
@                | <'('>        :printf("(");:
@                  expression
@                  <')'>        :printf(")");:

@ expression     = monadic_oper operand
@                | operand [ dyadic_oper operand ]

@ monadic_oper   = <'~'>        :printf("!");:
@                | <'-'>        :printf("-");:

# define GT '>'

@ dyadic_oper    = bit_oper | arith_oper | rel_oper

@ arith_oper     = <'+'>        :printf("+") ;:
@                | <'-'>        :printf("-") ;:
@                | <'*'>        :printf("*") ;:
@                | <'/'>        :printf("/") ;:
@                | <'\\'>       :printf("\\");:

@ bit_oper       = <'/'> <'\\'> :printf("&") ;:
@                | <'\\'> <'/'> :printf("|") ;:
@                | <GT> <'<'>   :printf("><");:
@                | <'<'> <'<'>  :printf("<<");:
@                | <GT> <GT>    :printf(">>");: 

@ rel_oper       = <'='>        :printf("==");:
@                | <'<'> <'='>  :printf("<=");:
@                | <GT>  <'='>  :printf(">=");:
@                | <'<'> <GT>   :printf("!=");:
@                | <'<'>        :printf("<") ;:
@                | <GT>         :printf(">") ;:


