# define BEGIN begin()

# include "occam.h"

void begin(){
     static int passes;
     int dup2();

     if(passes++==0){
     call_mode=0;
     optimize=0;

     dup2(0,5);
     dup2(1,6);
     if (p_argc>1)
        if (freopen(p_argv[1], "r", stdin)==NULL)
           fprintf(stderr,"error opening %s\n",p_argv[1]);
     if (p_argc>2)
        if (freopen(p_argv[2], "w", stdout)==NULL)
           fprintf(stderr,"error opening %s\n",p_argv[2]);
     if (p_argc>3)\
        fprintf(stderr,"usage %s [infile [outfile]]\n",p_argv[0]);
        }
}


		/* generics */

/* I used to have ...
 @ mult(n,p)      = )n==1(
 @                | p mult(n-1,p)
 */

@ mult(n,p)      = p*(n-1)

@ sep_list(s,p)  = p { s p }*

@sep_list1(s,p,n)= p(n) { s p(n) }*

/* indent(m,p) allows AT LEAST n>=m echoed blanks before p(n) */

long indentation = 0;

/* I have to be extremely careful here.
 * I'm using side-effects to avoid recursion.
 * I can do it because blank has no side-effects.
 */

@ indented(m,p)  = )(indentation=m,0)(
@                | {blank )(indentation+=1,1)(}* p(indentation)


/* I used to have ...
  @ indented(m,p)  = p(m)
  @                | blank p(m+1)
 */

@ indent(m,p)    = space(m) indented(m,p)

	        /* end generics */

/* I assume throughout that _processes_ begin at the keyword and
   don't print their trailing \n

   For neatness & efficiency, I'm insisting that successive
   processes are all indented to the SAME (or INCREASING) levels.
   The \n acts like a separator.

   clause(n) means start statement in col n or greater
   clauses(n) means start all statements in SAME col n or greater
   (isn't english wonderful?!)
 */

extern PARSER process;

@ clause(n)      = indent(n,CONST(process))

@ clauses(n)     = clause(n) { :printf(",\n");: clause(n) }*

 /* we finish with EOF */

@ occam          = clause(CONST(1)) ! $$

MAIN(occam)

